<template>
  <q-layout view="hHh lpR fFf">
    <q-page-container>
      <q-header elevated>
        <Toolbar :hasBackButton="true" :pageTitle="$t('trunks.page_title')" />
      </q-header>

      <q-page class="pl-fullpage">
        <h4 class="q-my-md">
          {{ $t('trunks.page_title') }}
        </h4>

        <q-list separator>
          <q-item v-for="trunk in trunks || {}" :key="trunk.caller_number">
            <TrunkCard :trunk="trunk" :updateTrunk="handleChange" />
          </q-item>
          <div v-if="loading">
            {{ $t('loading') }}
          </div>
          <div v-else-if="!trunks">
            {{ $t('trunks.no_trunks') }}
          </div>
          <div v-else class="centred">
            <q-btn class="save-button" color="green" icon="save" :label="$t('trunks.save_changes')"
              @click="e => saveChanges()" />
          </div>
        </q-list>
      </q-page>
    </q-page-container>
  </q-layout>
</template>
<script>
import { functions, db, } from "../../firebase";
import Toolbar from "../../components/Toolbar.vue";
import TrunkCard from "../../components/TrunkCard.vue"

export default {
  data()
  {
    return {
      trunks: undefined,
      changes: {},
      loading: true
    };
  },
  created()
  {
    this.$rtdbBind("trunks", db.ref('System/Trunks')).then(() => this.loading = false);
  },
  methods:
  {
    handleChange(changedTrunkId, newCosts, newCapacity, localOnly, localZero)
    {
      this.changes[changedTrunkId] = {
        capacity: newCapacity,
        costs: newCosts,
        removeIntCode: localOnly,
        addZeroToLocal: localZero
      }
    },
    async saveChanges()
    {
      try
      {
        this.$q.loading.show();

        for (const trunk in this.changes)
        {
          let newCosts = {};

          for (const code in this.changes[trunk].costs)
          {
            if (this.changes[trunk].costs[code].active)
            {
              newCosts[code] = this.changes[trunk].costs[code].cost;
            }
          }

          console.log(this.changes[trunk])

          const fbFunction = functions.httpsCallable("updateTrunk");
          await fbFunction({
            trunkId: trunk,
            supportedCodes: newCosts,
            capacity: this.changes[trunk].capacity,
            removeIntCode: this.changes[trunk].removeIntCode,
            addZeroToLocal: this.changes[trunk].addZeroToLocal
          });
        }

        this.$q.notify({
          type: 'positive',
          message: this.$t('trunks.save_success')
        })
      }
      catch (error)
      {
        console.log(error);
        this.$q.notify({
          type: 'negative',
          message: error
        })
      }
      this.$q.loading.hide();
    }
  },
  components: {
    Toolbar,
    TrunkCard
  },
};
</script>
<style scoped>
.centred {
  margin: 10px auto;
  width: 180px;
}
</style>
  